#include <stdlib.h>
#include <GL/glut.h>

#include "MapBlock.h"
#include "Base.h"
#include "NodeRenderer.h"
#include "TextureHandler.h"
#include <cstdio>
#include <random>

NodeRenderer renderer;
//BlockManager blockManager;
NodeManager nodeManager(0, 0);
NodeManager nodeManager1(1, 0);
TextureHandler textureHandler;

GLfloat playerX = 0;
GLfloat playerY = -30;
GLfloat playerZ = -100;
GLfloat playerRotX = 0;



void display()
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    glTranslatef(playerX, playerY, playerZ);
    glRotatef(playerRotX, .0F, 1.0F, .0F);

    glEnable(GL_TEXTURE_2D);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);


    glBegin(GL_QUADS);
        for(int x = 0; x < 16; x++)
        {
            for(int z = 0; z < 16; z++)
            {
                for(int y = 0; y < 256; y++)
                {
                    if(nodeManager.getNodeAt(x, y, z) > 0)
                    {
                        textureHandler.getTextureForNode(x, y, z);
                        renderer.renderNode(x, y, z);
                    }
                }
            }
        }

        for(int x = 0; x < 16; x++)
        {
            for(int z = 0; z < 16; z++)
            {
                for(int y = 0; y < 256; y++)
                {
                    if(nodeManager1.getNodeAt(x, y, z) > 0)
                    {
                        textureHandler.getTextureForNode(x, y, z);
                        renderer.renderNode(x, y, z);
                    }
                }
            }
        }

    glEnd();

    glFlush();
    glutSwapBuffers();


    glutPostRedisplay();
}


void reshape(int width, int height)
{
    glMatrixMode(GL_PROJECTION);

    glLoadIdentity();
    gluPerspective(20, width / (float) height, 5, 150);
    glViewport(0, 0, width, height);

    glMatrixMode(GL_MODELVIEW);
    glutPostRedisplay();
}

void KeyboardFunc(unsigned char key, int x, int y)
{
    if(key == 'a')
    {
        playerX += .8F;
    }

    if(key == 'd')
    {
        playerX -= .8F;
    }

    if(key == 'w')
    {
        playerZ += .8F;
    }

    if(key == 's')
    {
        playerZ -= .8F;
    }

    if(key == 'q')
    {
        playerY += .1F;
    }

    if(key == 'e')
    {
        playerY -= .1F;
    }

    if(key == 'f')
    {
        playerRotX -= .8F;
    }

    if(key == 'h')
    {
        playerRotX += .8F;
    }




    if(key == 27)
    {
        exit(0);
    }


}






int	main(int argc, char **argv)
{
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
    glutInitWindowSize(800, 600);
    glutCreateWindow("XtreemNodes Engine - By MCL Software and Cube Software");

    glClearColor(.2, .7, .8 , 255);
    glEnable(GL_DEPTH_TEST);


    // Load textures
    textureHandler.loadAllTextures();




    for(int x = 0; x < 16; x++)
    {
        for(int z = 0; z < 16; z++)
        {
            for(int y = 0; y < 256; y++)
            {
                nodeManager.addNode(rand() % 3, 0, x, y, z);
                //printf("\nGet node at: %i\n Is air: %i", nodeManager.getNodeAt(x, y + 1, z) == 0, nodeManager.isAir(x, y + 1, z));
            }
        }
    }

    for(int x = 0; x < 16; x++)
    {
        for(int z = 0; z < 16; z++)
        {
            for(int y = 0; y < 256; y++)
            {
                nodeManager1.addNode(rand() % 3, 0, x, y, z);
                //printf("\nGet node at: %i\n Is air: %i", nodeManager.getNodeAt(x, y + 1, z) == 0, nodeManager.isAir(x, y + 1, z));
            }
        }
    }


    glutDisplayFunc(&display);
    glutReshapeFunc(&reshape);
    glutKeyboardFunc(&KeyboardFunc);

    glutMainLoop();

    return 0;
}
